<?php
/*
Plugin Name: reCaptcha
Plugin URI: http://www.ramblingross.co.uk/fp-content/attachs/recaptcha-1-0.zip
Description: Antispam mechanism using the reCaptcha service.
Author: RamblingRoss
Version: 1.0
Author URI: http://www.ramblingross.co.uk
*/

add_action('comment_validate', 'plugin_recaptcha_validate');
add_action('comment_form', 'plugin_recaptcha_comment_form');

function plugin_recaptcha_setup() {
	global $fp_config;

	if (!plugin_getoptions('recaptcha','privatekey') && 
	    !plugin_getoptions('recaptcha','publickey')) {
		return -1;
	}
  
	return 1;		
}


if (class_exists('AdminPanelAction')){

	class admin_plugin_recaptcha extends AdminPanelAction { 
		
		var $langres = 'plugin:recaptcha';
		
		function setup() {
			$this->smarty->assign('admin_resource', "plugin:recaptcha/admin.plugin.recaptcha");
		}
		
		function main() {
			$recapcthaconf = plugin_getoptions('recaptcha');
      
			$recapcthaconf['privatekey'] = isset($recapcthaconf['privatekey']) ? $recapcthaconf['privatekey'] : "";
      
			$recapcthaconf['publicekey'] = isset($recapcthaconf['publickey']) ? $recapcthaconf['publickey'] : "";
            
			$this->smarty->assign('recaptchaconf', $recapcthaconf);
		}
		
		function onsubmit() {
			global $fp_config;
			
			if ($_POST['recaptcha-conf']){
				
				plugin_addoption('recaptcha', 'privatekey', $_POST['recaptcha-privatekey']);
				plugin_addoption('recaptcha', 'publickey', $_POST['recaptcha-publickey']);
				plugin_saveoptions('recaptcha');
				
				$this->smarty->assign('success', 1);
			} else {
			 	$this->smarty->assign('success', -1);
			}
			
			return 2;
		}		
	}

	admin_addpanelaction('plugin', 'recaptcha', true);

}

function plugin_recaptcha_validate() {
	
	// if user is loggedin we ignore the plugin
	if (user_loggedin())
		return true;
	
  // bring in recaptcha library
  require_once('inc/recaptchalib.php');

  // the response from reCAPTCHA
  $resp = null;

  //the error code from reCAPTCHA, if any
  $error = null;

  $resp = recaptcha_check_answer (plugin_getoptions('recaptcha','privatekey'),
                                  $_SERVER["REMOTE_ADDR"],
                                  $_POST["recaptcha_challenge_field"],
                                  $_POST["recaptcha_response_field"]);

  if ($resp->is_valid) {
    return true;
  }

	global $smarty;
	$lang = lang_load('plugin:recaptcha');
		
	$smarty->append('error', $lang['plugin']['recaptcha']['error']);
	
	return false;
}

function plugin_recaptcha_comment_form() {
	
  // bring in recaptcha library
  require_once('inc/recaptchalib.php');

	// load plugin strings
	// they're located under plugin.PLUGINNAME/lang/LANGID/
	$lang = lang_load('plugin:recaptcha');

  // display recaptcha
  echo "<p><label class='textlabel' for='recaptcha_challenge_field'>{$lang['plugin']['recaptcha']['prefix']}</label><br />";
  echo recaptcha_get_html(plugin_getoptions('recaptcha','publickey'));
	echo "</p>";
}


?>
